#Dean Feller
#Assignment 9
#November 15, 2020


class Connect4(object):
    
	def __init__(self, width, height, window=None):
		self.width = width
		self.height = height
		self.data = []
		
		for row in range(self.height):
			boardRow = []
			for col in range(self.width):
				boardRow += [' ']
			self.data += [boardRow]
		
	def __repr__(self):
		s = ''
		for row in range(self.height):
			s +=  '|'
			for col in range(self.width):
				s += self.data[row][col] + '|'
			s += '\n'
		s += '--' * self.width + '-\n'
		
		for col in range(self.width):
			s += ' ' + str(col % 10)
		s += '\n'
		return s
		
	#Add checker in chosen column
	def addMove(self, col, ox):
		if self.allowsMove(col):
			for row in range(self.height):
				if self.data[row][col] != ' ':
					self.data[row - 1][col] = ox
					return True
			
			self.data[self.height - 1][col] = ox
			return True
		
		else:
			return False
	
	#Clear the board
	def clear(self):
		for row in range(self.height):
			for col in range(self.width):
				self.data[row - 1][col] = ' '
	
	#Delete a top checker from chosen column
	def delMove(self, col):
		for row in range(self.height):
			if self.data[row][col] != ' ':
				self.data[row][col] = ' '
				break
	
	#Check if the chosen move is valid
	def allowsMove(self, col):
		if 0 <= col <= self.width:
			return self.data[0][col] == ' '
			
		else:
			return False
	
	#Check if the board is full
	def isFull(self):
		full = 0
		for col in range(self.width):
			full += self.allowsMove(col)
		
		if full == 0:
			return True
		
		return False
		
	#Check if the current player has 4 in a row
	def winsFor(self,ox):
		#horizontal
		for row in range(self.height):
			for col in range(self.width - 3):
				if self.data[row][col] == ox and \
				self.data[row][col+1] == ox and \
				self.data[row][col+2] == ox and \
				self.data[row][col+3] == ox:
					return True
					
		#vertical
		for row in range(self.height - 3):
			for col in range(self.width):
				if self.data[row][col] == ox and \
				self.data[row + 1][col] == ox and \
				self.data[row + 2][col] == ox and \
				self.data[row + 3][col] == ox:
					return True
					
		#diagonal up
		for row in range(self.height):
			for col in range(self.width - 3):
				if self.data[row][col] == ox and \
				self.data[row - 1][col + 1] == ox and \
				self.data[row - 2][col + 2] == ox and \
				self.data[row - 3][col + 3] == ox:
					return True
		
		#diagonal down
		for row in range(self.height - 3):
			for col in range(self.width - 3):
				if self.data[row][col] == ox and \
				self.data[row + 1][col + 1] == ox and \
				self.data[row + 2][col + 2] == ox and \
				self.data[row + 3][col + 3] == ox:
					return True
					
		return False

	#Run turns and checks
	def hostGame(self):
		turn = 0
		
		while self.hostGame != None and turn <= self.height * self.width:
			if turn % 2 == 0:
				ox = 'X'
			else:
				ox = 'O'
		
			print(self)
			print(ox + "'s turn. Pick a column, any column.")
			col = int(input())
			print('\n')
			
			if self.allowsMove(col) == False:
				print("You fool. You absolute buffoon. Could you not tell \
it was an invalid move? Try again.")
				turn -= 1
			else:
				self.addMove(col, ox)

			if self.winsFor(ox):
				print(self)
				print(ox + " wins! Congratulations on your $24,000 \
paid vacation to Bermuda!")
				return None

			if self.isFull():
				print(self)
				print("Tie: everyone gets a trophy for participation!")
				return None
			
			else:
				turn += 1
				
def main():
	b = Connect4(7,6)
	b.hostGame()

if __name__ == '__main__':
	main()
	
	
	
	
	